
data test;
	input p m r a1 a2;
datalines;
1 1 0.5 1 2
1 2 1 2 3
1 3 1.5 3 4
1 4 2 4 5
1 5 2.5 5 6
2 1 1 6 7
2 2 1.5 7 8
2 3 2 8 9
2 4 2.5 9 10
2 5 3 10 11
;
run;




proc optmodel PRESOLVER=NONE;
set I;
number ID{I};
number r{I}, p{I},m{I},a1{I}, a2{I};
var der{I}, der1{I},value;
read data test into I = [_n_]
ID = _n_ r = r a1 = a1 a2 = a2 p=p m=m;
var d >=-1000 <=1000;

for {j in I} do;
if m[j]=0 then der[j]=1+(r[j]+d)/3;
else der[j]=der[j-1]*(1+(r[j]+d)/3);
der1[j]=(a2[j]-a1[j])/der[j];
end; 

value=sum{k in I} der1[k];
min g=abs((value/2)-1);

solve with NLPC OBJ g; 


quit;
